Subject: [tsvwg] Re: New Version Notification for draft-tahiliani-tsvwg-fq-pie-00.txt
From: Sebastian Moeller <[email-masked]>
To: "Mohit P. Tahiliani" <tahiliani=[email-masked]>
Cc: [email-masked]
Date: Tue, 11 Mar 2025 17:50:18 +0100
List-Id: Transport Area Working Group <tsvwg.ietf.org>

Hi Mohit,

thanks. I like this, short and sweet. I do have a question though (probably easy to answer) abgout the following section:

Lastly, if an incoming packet arrives when the total number of enqueued packets has already saturated the queue capacity, FQ-PIE drops the packet without further processing. In contrast, FQ-CoDel identifies the queue with the largest current byte count (i.e., a "fat flow") when the queue capacity is saturated and drops half of the packets from this queue (up to a maximum of 64 packets, as specified in Section 4.1 of [RFC8290]). FQ-PIE does not adopt this approach for the reasons explained below.

One thing that fq_codel but als DualQ seem to do on overload is take a big shovel instead of a scalpel. So while I have no idea which packets to drop, maybe doing a bit more than "close the queue for new comers" might be in order. Especially since together with ECN there is the potential for an unresponsive flow to fill the queue without feeling the "pain" for doing so? Yes, mischievous adversarial traffic might not be a target to optimize for, but I wonder how the drop only on enqueue can ever be safe with ECN?

> On 26. Jan 2025, at 06:59, Mohit P. Tahiliani <tahiliani=[email-masked]> wrote:
> 
> Hi all,
> 
> I submitted an I-D on Flow Queue PIE (https://datatracker.ietf.org/doc/draft-tahiliani-tsvwg-fq-pie/) during the IETF 121 at Dublin, and mentioned in briefly during the last tsvwg session on Friday.
> 
> Flow Queue PIE is a hybrid packet scheduler and Active Queue Management (AQM) algorithm.
> 
> It has been incorporated into the mainline Linux kernel as a queuing discipline (qdisc) and is supported by several Linux distributions. Additionally, an implementation of FQ-PIE is available in the ns-3 network simulator.
> 
> If you have feedback or if there is anything missing, please let me know.
> 
> Thanks and Regards,
> Mohit P. Tahiliani
> 
> ---------- Forwarded message ---------
> From: <[email-masked]>
> Date: Fri, Nov 8, 2024 at 6:50 AM
> Subject: New Version Notification for draft-tahiliani-tsvwg-fq-pie-00.txt
> To: Mohit P. Tahiliani <[email-masked]>
> 
> 
> A new version of Internet-Draft draft-tahiliani-tsvwg-fq-pie-00.txt has been
> successfully submitted by Mohit Tahiliani and posted to the
> IETF repository.
> 
> Name:     draft-tahiliani-tsvwg-fq-pie
> Revision: 00
> Title:    Flow Queue PIE: A Hybrid Packet Scheduler and Active Queue Management Algorithm
> Date:     2024-11-08
> Group:    Individual Submission
> Pages:    8
> URL:      https://www.ietf.org/archive/id/draft-tahiliani-tsvwg-fq-pie-00.txt
> Status:   https://datatracker.ietf.org/doc/draft-tahiliani-tsvwg-fq-pie/
> HTML:     https://www.ietf.org/archive/id/draft-tahiliani-tsvwg-fq-pie-00.html
> HTMLized: https://datatracker.ietf.org/doc/html/draft-tahiliani-tsvwg-fq-pie
> 
> 
> Abstract:
> 
>    This document presents Flow Queue Proportional Integral controller
>    Enhanced (FQ-PIE), a hybrid packet scheduler and Active Queue
>    Management (AQM) algorithm to isolate flows and tackle the problem of
>    bufferbloat.  FQ-PIE uses hashing to classify incoming packets into
>    different queues and provide flow isolation.  Packets are dequeued by
>    using a variant of the round robin scheduler.  Each such flow is
>    managed by the PIE algorithm to maintain high link utilization while
>    controlling the queue delay to a target value.
> 
> 
> 
> The IETF Secretariat
> 
>